# scan2report

### On first run (Linux)

```bash
sudo locale-gen cs_CZ
sudo locale-gen cs_CZ.UTF-8
sudo update-locale

# Todo: Create virtual environment to isolate the packages.
python3 -m pip uninstall docx
python3 -m pip install -U -r requirements.txt
```

### Run example
This command presumes that some sample data is in the parent folder.

```bash
python3 scan2report.py -o test.docx ../sample-*
```


### Popis od pana Svobody

použití viz ./scan2report.py -h

```
Usage: ./scan2report.py [OPTIONS] .. <FILE> ..
<FILE>: Input files. Supported formats: Nessus XML report, Lynis Report (.dat). 
OPTIONS:
    -d, --debug (enables also plugin IDs in output document)
    -i, --ignore <plugin_ids>: comma separated list of plugin ids to be ignored (ex. nessus_57582), default: none
    -l, --lang <language>: report language (cs, en), default: cs 
    -m, --min-severity <num>: minimal severity (0 - info ... 4 - critical), default: 1 
    -o, --output <file>: write output to file, default: out.docx 
    -p, --profile <name>: use selected profile (default, internal), defaut value: default 
    -r, --resolve-redirects: resolve redirects via nessus.com, default: False 
    -s, --skip-services: do not generate open ports table, default: False 
    -S, --plugin-stats: do not generate report, only plugin hit stats, default: False 
    -t, --template <file>: use specified template document, default: templates/tns.docx
```

Například tedy: `/scan2report.py -o test.docx ../sample-*`

- plugins/groups.json - definice pro seskupování nálezů (v příkladu vygenerovaném výše uvedeným příkladem jsou seskupené nálezy týkající se SSH), klíč "#name" se na nic nepoužívá, je to jen pro přehled při editaci souboru
- plugins/profiles.json - pomocí --profile lze zvolit "profil", který ovlivňuje jak se zpráva vygeneruje, např. při generování zprávy z testu interní sítě neuvádíme tabulku detekovaných služeb a ignorujeme některé pluginy
- plugins/{​​​​​​​​​​​​​​​​​jazyk}​​​​​​​​​​​​​​​​​/*.json - hotové soubory se šablonami nálezů (některé jsou starší, většina položek "*_original" přibyla do šablony později)
- plugins/{​​​​​​​​​​​​​​​​​jazyk}​​​​​​​​​​​​​​​​​/templates/*.json - do tohoto adresáře generuje skript šablonu pro texty popisu zranitelnosti, které vezme ze zpracovávaného skenu, momentálně fungujeme tak, že texty v souborech v tomto adresáři upravíme, přesuneme o adresář výše (do plugins/{​​​​​​​​​​​​​​​​​​​jazyk}​​​​​​​​​​​​​​​​​​​/) a spustíme generování zprávy znovu
- templates/ - obsahuje vzorový docx, jež se bere jako předloha pro generování výstupu a profil konfigurace používaný při generování zprávy z auditu konfigurace pomocí Lynisu
